<?php
include "BancoMongo.php";
use MongoDB\Driver\BulkWrite;
use MongoDB\BSON\ObjectID;
use MongoDB\Driver\Query;
class Cliente implements JsonSerializable 
{
    private $idCliente;
    private $nome;
    private $email;
    private $senha;
    private $nascimento;
    private $salario;
    private $banco;
    private $colecao = "aulaPAW.Clientes";
    public function jsonSerialize() {
        $json= array();
        $json['idCliente']=$this->getIdCliente();
        $json['nome']=$this->getNome();
        $json['email']=$this->getEmail();
        $json['nascimento']=$this->getNascimento();
        $json['salario']=$this->getSalario();
        return $json;
    }
    public function cadastrar(){
        $this->banco = new BancoMongo();
        $documento = new BulkWrite(); 
        $doc = ['nome' => $this->getNome(), 
                'email' => $this->getEmail(), 
                'nascimento' => $this->getNascimento(),
                'salario' => $this->getSalario(),
                'senha' => $this->getSenha(),
                ];
        $idCadastrado= (string) $documento->insert($doc);
        $this->banco->getConexao()->executeBulkWrite($this->colecao, $documento);  
        $this->setIdCliente( $idCadastrado);
        return $this;
    }
    public function excluir(){
        $documento = new BulkWrite();
        $this->banco = new BancoMongo();
        $filter = ['_id' => new ObjectID($this->idCliente)];
        $options = ['limit' => 1];
        
        $documento->delete($filter, $options);
        $this->banco->getConexao()->executeBulkWrite($this->colecao, $documento);
        return true;
    }
    public function atualizar(){
        $this->banco = new BancoMongo();
        $documento = new BulkWrite();
        $filter = ['_id' => new ObjectID($this->idCliente)];
        $update = ['$set' =>  [ 'nome'=>$this->getNome(),
                                'email'=>$this->getEmail(),
                                'senha'=>$this->getSenha(),
                                'salario'=> $this->getSalario(),
                                'nascimento'=> $this->getNascimento()
                                ]];
        $options = ['multi' => false, 'upsert' => false];
        $documento->update($filter, $update, $options);
        $cursor= $this->banco->getConexao()->executeBulkWrite($this->colecao, $documento);   
        return true;
    }

    public function buscar($idCliente){
        $this->banco = new BancoMongo();
        $filter = ['_id' => new ObjectID($idCliente)];
        //echo $this->idCliente;
        $options = ['limit' => 1];
        $query = new Query($filter, $options);
        $cursor= $this->banco->getConexao()->executeQuery($this->colecao, $query); 
        foreach ($cursor as $document) {
            $this->setIdCliente($idCliente);
            $this->setNome($document->nome);
            $this->setEmail($document->email);
            $this->setSalario($document->salario);
            $this->setNascimento($document->nascimento);  
        }
        return $this;
    
    }
    public function listar()
    {
      
        $this->banco = new BancoMongo();
        $vetorClientes = array();
        $i = 0;   

        $filter = array();
        $options = [];
        $query = new Query($filter, $options);
        $cursor= $this->banco->getConexao()->executeQuery($this->colecao, $query); 
        foreach ($cursor as $document) {
            $vetorClientes[$i]= new Cliente();
           $vetorClientes[$i]->setIdCliente((String) new ObjectID($document->_id) );
          
            $vetorClientes[$i]->setNome($document->nome);
            $vetorClientes[$i]->setEmail($document->email);
            $vetorClientes[$i]->setSalario($document->salario);
            $vetorClientes[$i]->setNascimento($document->nascimento);  
            $i++;
        }
        return $vetorClientes;
    }
    public function getIdCliente()
    {
        return  $this->idCliente;
    }
    public function setIdCliente($v)
    {
        $this->idCliente = $v;
    }
    public function getNome()
    {
        return $this->nome;
    }
    public function setNome($nome)
    {
        $this->nome = $nome;
    }
    public function getEmail()
    {
        return $this->email;
    }
    public function setEmail($v)
    {
        $this->email = $v;
    }
    public function getSenha()
    {
        return $this->senha;
    }
    public function setSenha($v)
    {
        $this->senha = $v;
    }
    public function getNascimento()
    {
        return $this->nascimento;
    }
    public function setNascimento($v)
    {
        $this->nascimento = $v;
    }
    public function getSalario()
    {
        return $this->salario;
    }
    public function setSalario($v)
    {
        $this->salario = $v;
    }
}
?>
